Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
FSDK.TabOrderMgr Class Reference

## Public Member Functions
| AdjustStructureOrder (annot_array)
| Adjust the structure order with specified annotations, and tab order type will be set to FSDK.TabOrderMgr.e_Structure at the same time. More...
| constructor (page)
| Constructor, from a PDF page object. More...
| GetFirstAnnot ()
| Get the first annotation in current tab order. More...
| GetLastAnnot ()
| Get the last annotation in current tab order. More...
| GetNextAnnot (annot)
| Get the next annotation of specified annotation in current tab order. More...
| GetOrderType ()
| Get the tab order type. More...
| GetPrevAnnot (annot)
| Get the previous annotation of specified annotation in current tab order. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| Reload ()
| Reload the tab order of annotations. More...
| SetOrderType (order_type)
| Set the tab order type. More...

## Static Public Attributes
static | e_Column
| C (column order): Annotations are visited in columns running vertically up and down the page.
static | e_None
| Enumeration for tab order type. More...
static | e_Row
| R (row order): Annotations are visited in rows running horizontally across the page.
static | e_Structure
| S (structure order): Annotations are visited in the order in which they appear in the structure tree.

## Detailed Description

Tab order is the order to navigate through annotations on a PDF page by using Tab key in keyboard. This class offers functions to manage the order of moving the keyboard focus among annotations on a PDF page. Tab order manager will ignore following types of annotations:
note annotations which are as reply annotations, note annotations which are as state annotations, pop-up annotations, annotations whose flags contain FSDK.Annot.e_FlagHidden.
This class offers functions to get the order type and get annotations one by one in the order type. This class also offers functions to change the order type:

- FSDK.TabOrderMgr.SetOrderType can be used to change the tab order type. Specially, if the tab order type is changed to FSDK.TabOrderMgr.e_Structure, function FSDK.TabOrderMgr.AdjustStructureOrder could be called to set the order.
- Function FSDK.TabOrderMgr.AdjustStructureOrder can be called directly to change the order type to structure order and set the structure order at the same time.

After FSDK.TabOrderMgr.SetOrderType being used or calling function FSDK.TabOrderMgr.AdjustStructureOrder, function FSDK.TabOrderMgr.Reload should be called; otherwise the annotations' order may not be changed as expected.

See also
  FSDK.PDFPage
  FSDK.Annot

## Member Function Documentation

## ◆ AdjustStructureOrder()

FSDK.TabOrderMgr.AdjustStructureOrder | ( | annot_array |  | ) |

Adjust the structure order with specified annotations, and tab order type will be set to FSDK.TabOrderMgr.e_Structure at the same time.

This function is used to adjust the annotation order for structure tab order. First, re-order annotations in the input array according to the order in this array, and then re-order the reset annotations (which are not included in the input array) by the reading direction of PDF document.
After this function succeeds, indexes of all annotations in the related PDF page will be changed.

Parameters

  [in] | annot_array | An array of annotations which will be re-ordered first for structure tab order. All the annotations in this array should belong to the same page as the one related to current tab order manager. These annotations should all be valid and should be different from each other.

Returns
  true means success, while false means failure.

## ◆ constructor()

FSDK.TabOrderMgr.constructor | ( | page |  | ) |

Constructor, from a PDF page object.

Parameters

  [in] | page | A valid PDF page.

## ◆ GetFirstAnnot()

FSDK.TabOrderMgr.GetFirstAnnot | ( |  | ) |

Get the first annotation in current tab order.

Returns
  The first annotation. If the return value of function FSDK.Annot.IsEmpty for the returned annotation object is true, that means there is no annotation.

## ◆ GetLastAnnot()

FSDK.TabOrderMgr.GetLastAnnot | ( |  | ) |

Get the last annotation in current tab order.

Returns
  The last annotation. If the return value of function FSDK.Annot.IsEmpty for the returned annotation object is true, that means there is no annotation.

## ◆ GetNextAnnot()

FSDK.TabOrderMgr.GetNextAnnot | ( | annot |  | ) |

Get the next annotation of specified annotation in current tab order.

Parameters

  [in] | annot | The valid specified annotation.

Returns
  The next annotation. If the return value of function FSDK.Annot.IsEmpty for the returned annotation object is true, that means the specified annotation is the last annotation in current tab order.

## ◆ GetOrderType()

FSDK.TabOrderMgr.GetOrderType | ( |  | ) |

Get the tab order type.

Returns
  The tab order type. Please refer to values starting from FSDK.TabOrderMgr.e_None and this would be one of these values.

## ◆ GetPrevAnnot()

FSDK.TabOrderMgr.GetPrevAnnot | ( | annot |  | ) |

Get the previous annotation of specified annotation in current tab order.

Parameters

  [in] | annot | The valid specified annotation.

Returns
  The previous annotation. If the return value of function FSDK.Annot.IsEmpty for the returned annotation object is true, that means the specified annotation is the first annotation in current tab order.

## ◆ IsEmpty()

FSDK.TabOrderMgr.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ Reload()

FSDK.TabOrderMgr.Reload | ( |  | ) |

Reload the tab order of annotations.

This function should be called when:

- any annotation in related PDF page is moved/deleted/added;
- related page's rotation is changed;
- reading direction of related PDF document is changed;
- FSDK.TabOrderMgr.SetOrderType is used or function FSDK.TabOrderMgr.AdjustStructureOrder is called to change the tab order type or structure order.

Returns
  None.

## ◆ SetOrderType()

FSDK.TabOrderMgr.SetOrderType | ( | order_type |  | ) |

Set the tab order type.

Parameters

  [in] | order_type | The new tab order type. It should be one of following values: FSDK.TabOrderMgr.e_None: means not to use tab order. FSDK.TabOrderMgr.e_Row: means to use row order. FSDK.TabOrderMgr.e_Column: means to use column order. FSDK.TabOrderMgr.e_Structure: means to use struct order and then function FSDK.TabOrderMgr.AdjustStructureOrder could be called to set the order.

Returns
  None.

## Member Data Documentation

## ◆ e_None

FSDK.TabOrderMgr.e_None
| static

Enumeration for tab order type.

Values of this enumeration should be used alone.

None (index order): Annotations are visited in annotation's index across the page.